#version 150

in vec3 Position;
in vec2 UV0;
in vec4 Color;

uniform sampler2D Sampler0;
#moj_import <minecraft:dynamictransforms.glsl>
#moj_import <minecraft:projection.glsl>

out vec2 texCoord0;
out vec4 vertexColor;


vec2[] corners = vec2[](vec2(0, 0), vec2(0, 1), vec2(1, 1), vec2(1, 0)); // this is just defining the corners

void main() {

    vec3 pos = Position;
    
    int vertID = gl_VertexID % 4;

    vec2 corner = corners[vertID];
    vec4 color = round(texture(Sampler0, UV0-(0.0001*corner))*255);


    if(color.a == 1){
        if(color.r == 1){

            pos.xy += ((corner-0.5)*2*8);

        }
    }

    //====================================================
    gl_Position = ProjMat * ModelViewMat * vec4(pos, 1.0);
    texCoord0 = UV0;
    vertexColor = Color;
}
