#version 150

in vec3 Position;
in vec2 UV0;
in vec4 Color;

uniform sampler2D Sampler0;
uniform mat4 ModelViewMat;
uniform mat4 ProjMat;

out vec2 texCoord0;
out vec4 vertexColor;


vec2[] corners = vec2[](vec2(0, 0), vec2(0, 1), vec2(1, 1), vec2(1, 0)); // this is just defining the corners

void main() {

    vec3 pos = Position; //position
    
    int vertID = gl_VertexID % 4;  // vertex id (it starts from 0 top left and goes counter clockwise)

    vec2 corner = corners[vertID];
    vec4 color = round(texture(Sampler0, UV0-(0.0001*corner))*255); // the color of the corner pixels 


    if(color.a == 1){ //checks if the corner pixels are control
        if(color.r == 1){

            pos.xy += ((corner-0.5)*2*8); // this extends the texture 8 pixels on each side 

        }
    }

    //====================================================
    gl_Position = ProjMat * ModelViewMat * vec4(pos, 1.0);
    texCoord0 = UV0;
    vertexColor = Color;
}
